Kea: isc::dhcp::SubnetConfigParser Class Reference

| Kea 3.2.0-git

isc::dhcp::SubnetConfigParser Class Referenceabstract

this class parses a single subnet More...

`#include <dhcp_parsers.h>`

Inheritance diagram for isc::dhcp::SubnetConfigParser:
[legend]

## Public Member Functions
| SubnetConfigParser (uint16_t family, bool check_iface=true)
| constructor
virtual | ~SubnetConfigParser ()
| virtual destructor (does nothing)
Public Member Functions inherited from isc::dhcp::BaseNetworkParser
template<typename DdnsOwnerTypePtr>
void | parseDdnsParameters (const data::ConstElementPtr &config, DdnsOwnerTypePtr owner)
| Parses parameters pertaining to DDNS behavior.
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t.
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t.
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value.
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet.

## Protected Member Functions
virtual boost::shared_ptr< OptionDataListParser > | createOptionDataListParser () const
| Returns an instance of the `OptionDataListParser` to be used in parsing the option-data structure.
virtual boost::shared_ptr< PoolsListParser > | createPoolsListParser () const =0
| Returns an instance of the `PoolsListParser` to be used in parsing the address pools.
void | createSubnet (isc::data::ConstElementPtr data)
| Create a new subnet using a data from child parsers.
virtual void | initSubnet (isc::data::ConstElementPtr params, isc::asiolink::IOAddress addr, uint8_t len)=0
| Instantiates the subnet based on a given IP prefix and prefix length.
SubnetPtr | parse (isc::data::ConstElementPtr subnet, bool encapsulate_options)
| parses a subnet description and returns Subnet{4,6} structure
Protected Member Functions inherited from isc::dhcp::BaseNetworkParser
void | parseAdaptiveLeaseTimeParam (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses parameter related to adaptive lease time.
void | parseAllocatorParams (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses parameters pertaining to allocator selection.
void | parseCacheParams (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses parameters related to lease cache settings.
void | parseCommon (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses common parameters.
void | parseDdnsParams (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses parameters pertaining to DDNS behavior.
void | parseOfferLft (const data::ConstElementPtr &network_data, Network4Ptr &network)
| Parses offer-lifetime parameter (v4 only).
void | parsePdAllocatorParams (const data::ConstElementPtr &network_data, Network6Ptr &network)
| Parses parameters pertaining to prefix delegation allocator selection.
void | parseTeePercents (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses parameters related to "percent" timers settings.
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type, target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope.
template<typename int_type>
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope.

## Protected Attributes
uint16_t | address_family_
| Address family: `AF_INET` or `AF_INET6`.
bool | check_iface_
| Check if the specified interface exists in the system.
PoolStoragePtr | pools_
| Storage for pools belonging to this subnet.
isc::dhcp::Network::RelayInfoPtr | relay_info_
| Pointer to relay information.
isc::dhcp::SubnetPtr | subnet_
| Pointer to the created subnet object.

## Additional Inherited Members
Public Types inherited from isc::dhcp::BaseNetworkParser
typedef std::function< void(const isc::dhcp::ClientClass &)> | ClassAdderFunc
Static Public Member Functions inherited from isc::dhcp::BaseNetworkParser
static void | getAdditionalClassesElem (data::ConstElementPtr params, ClassAdderFunc adder_func)
| Fetches the element for either 'evaluate-additional-classes' or deprecated 'require-client-classes'.
static void | getClientClassesElem (data::ConstElementPtr params, ClassAdderFunc adder_func)
| Fetches the element for either 'client-classes' or deprecated 'client-class'.
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type.
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present.
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child.
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope.
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope.
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range.
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element.
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope.
template<typename T>
static void | rangeCheckedInteger (isc::data::ConstElementPtr scope, const std::string &name, T &output_value)
| Fetches a range-checked integer parameter from a scope.
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values.
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list.

## Detailed Description

this class parses a single subnet

There are dedicated Subnet4ConfigParser and Subnet6ConfigParser classes. They provide specialized parse() methods that return Subnet4Ptr or Subnet6Ptr.

This class parses the whole subnet definition. This class attempts to unify the code between v4 and v6 as much as possible. As a result, the flow is somewhat complex and it looks as follows:

    ------- Base class

/ | /--— Derived class

1. * SubnetXConfigParser::parse() is called.
2. * SubnetConfigParser::parse() is called.
3. * SubnetConfigParser::createSubnet() is called.
4. * SubnetXConfigParser::initSubnet() is called (Subnet4 or Subnet6 is instantiated here and family specific parameters are set)
5. Control returns to createSubnet() (step 3) and common parameters are set.

Definition at line 512 of file dhcp_parsers.h.

## Constructor & Destructor Documentation

## ◆ SubnetConfigParser()

isc::dhcp::SubnetConfigParser::SubnetConfigParser | ( | uint16_t | family,
|  | bool | check_iface = true )
| explicit

constructor

Parameters

  family | address family: `AF_INET` or `AF_INET6`
  check_iface | Check if the specified interface exists in the system.

Definition at line 581 of file dhcp_parsers.cc.

References address_family_, check_iface_, pools_, and relay_info_.

Referenced by isc::dhcp::Subnet4ConfigParser::Subnet4ConfigParser(), and isc::dhcp::Subnet6ConfigParser::Subnet6ConfigParser().

## ◆ ~SubnetConfigParser()

virtual isc::dhcp::SubnetConfigParser::~SubnetConfigParser | ( |  | ) |
| inlinevirtual

virtual destructor (does nothing)

Definition at line 523 of file dhcp_parsers.h.

## Member Function Documentation

## ◆ createOptionDataListParser()

boost::shared_ptr< OptionDataListParser > isc::dhcp::SubnetConfigParser::createOptionDataListParser | ( |  | ) | const
| protectedvirtual

Returns an instance of the `OptionDataListParser` to be used in parsing the option-data structure.

This function can be overridden in the child classes to supply a custom parser for option data.

Returns
  an instance of the `OptionDataListParser`.

Definition at line 708 of file dhcp_parsers.cc.

References address_family_.

Referenced by parse().

## ◆ createPoolsListParser()

virtual boost::shared_ptr< PoolsListParser > isc::dhcp::SubnetConfigParser::createPoolsListParser | ( |  | ) | const
| protectedpure virtual

Returns an instance of the `PoolsListParser` to be used in parsing the address pools.

This function can be overridden in the child classes to supply a custom parser for the pools.

Returns
  an instance of the `PoolsListParser`.

Implemented in isc::dhcp::Subnet4ConfigParser, and isc::dhcp::Subnet6ConfigParser.

## ◆ createSubnet()

void isc::dhcp::SubnetConfigParser::createSubnet | ( | isc::data::ConstElementPtr | data | ) |
| protected

Create a new subnet using a data from child parsers.

Parameters

  data | Element map that describes the subnet

Exceptions

  isc::dhcp::DhcpConfigError | if subnet configuration parsing failed.

Definition at line 622 of file dhcp_parsers.cc.

References isc::data::SimpleParser::getString(), initSubnet(), isc::dhcp::CfgMgr::instance(), isc_throw, isc::asiolink::IOAddress::isV4(), isc::asiolink::IOAddress::isV6(), isc::data::Element::map, pools_, subnet_, and isc::Exception::what().

Referenced by parse().

Here is the call graph for this function:

## ◆ initSubnet()

virtual void isc::dhcp::SubnetConfigParser::initSubnet | ( | isc::data::ConstElementPtr | params,
|  | isc::asiolink::IOAddress | addr,
|  | uint8_t | len )
| protectedpure virtual

Instantiates the subnet based on a given IP prefix and prefix length.

Parameters

  params | configuration parameters for that subnet
  addr | is the IP prefix of the subnet.
  len | is the prefix length

Implemented in isc::dhcp::Subnet4ConfigParser, and isc::dhcp::Subnet6ConfigParser.

Referenced by createSubnet().

## ◆ parse()

SubnetPtr isc::dhcp::SubnetConfigParser::parse | ( | isc::data::ConstElementPtr | subnet,
|  | bool | encapsulate_options )
| protected

parses a subnet description and returns Subnet{4,6} structure

This method is called from specialized (Subnet4ConfigParser or Subnet6ConfigParser) classes.

Parameters

  subnet | pointer to the content of subnet definition
  encapsulate_options | a boolean parameter indicating if the parsed options should be encapsulated with suboptions.

Returns
  a pointer to newly created subnet

Exceptions

  isc::DhcpConfigError | if subnet configuration parsing failed.

Definition at line 589 of file dhcp_parsers.cc.

References address_family_, createOptionDataListParser(), createSubnet(), isc_throw, isc::dhcp::RelayInfoParser::parse(), relay_info_, subnet_, isc::dhcp::Option::V4, and isc::dhcp::Option::V6.

Referenced by isc::dhcp::Subnet4ConfigParser::parse(), and isc::dhcp::Subnet6ConfigParser::parse().

Here is the call graph for this function:

## Member Data Documentation

## ◆ address_family_

uint16_t isc::dhcp::SubnetConfigParser::address_family_
| protected

Address family: `AF_INET` or `AF_INET6`.

Definition at line 584 of file dhcp_parsers.h.

Referenced by SubnetConfigParser(), createOptionDataListParser(), and parse().

## ◆ check_iface_

bool isc::dhcp::SubnetConfigParser::check_iface_
| protected

Check if the specified interface exists in the system.

Definition at line 590 of file dhcp_parsers.h.

Referenced by SubnetConfigParser(), isc::dhcp::Subnet4ConfigParser::initSubnet(), and isc::dhcp::Subnet6ConfigParser::initSubnet().

## ◆ pools_

PoolStoragePtr isc::dhcp::SubnetConfigParser::pools_
| protected

Storage for pools belonging to this subnet.

Definition at line 578 of file dhcp_parsers.h.

Referenced by SubnetConfigParser(), createSubnet(), isc::dhcp::Subnet4ConfigParser::parse(), and isc::dhcp::Subnet6ConfigParser::parse().

## ◆ relay_info_

isc::dhcp::Network::RelayInfoPtr isc::dhcp::SubnetConfigParser::relay_info_
| protected

Pointer to relay information.

Definition at line 587 of file dhcp_parsers.h.

Referenced by SubnetConfigParser(), isc::dhcp::Subnet4ConfigParser::parse(), isc::dhcp::Subnet6ConfigParser::parse(), and parse().

## ◆ subnet_

isc::dhcp::SubnetPtr isc::dhcp::SubnetConfigParser::subnet_
| protected

Pointer to the created subnet object.

Definition at line 581 of file dhcp_parsers.h.

Referenced by createSubnet(), isc::dhcp::Subnet4ConfigParser::initSubnet(), isc::dhcp::Subnet6ConfigParser::initSubnet(), isc::dhcp::Subnet4ConfigParser::parse(), isc::dhcp::Subnet6ConfigParser::parse(), and parse().

The documentation for this class was generated from the following files:

- dhcp_parsers.h
- dhcp_parsers.cc